<template lang="pug">
.fixed-full.text-white(style="background:#121212")
  .absolute-top-right().q-pa-md
    q-spinner(size="50px" color="grey-9" style="right:8px;top:8px;" v-show="loading").absolute
    q-circular-progress(size="34px" color="grey-8" :value="cacheprogress/TOLOAD * 100" v-show="cacheprogress<TOLOAD")
    q-btn(round flat dense @click="loadNextBatch" style="top:24px;right:16px;").absolute
  .absolute-top-right(style="width:50px;top:10px;")
    .relative
      
      
      //- div {{waitingforcache}}
  .fullscreen(v-show="!hasClicked").bg-black.z-max
    .absolute-center
      q-btn(color="primary" size="xl" icon="play_arrow" @click="startMe") Connect

  .row.justify-center.items-stretch.text-center(style="height:70px;overflow:hidden;")
    .col-auto.bg-white
      .column.justify-center.items-center.full-height
        .col-auto
          img(src="@/assets/CRTV-Mosaic-Logo.gif" style="")
    .col
    .col-auto.self-center
      .column.justify-center.items-center.full-height
        .col-auto
          Clock(:timezone="-5" :name="'Panama'")
    .col-auto.self-center
      .column.justify-center.items-center.full-height
        .col-auto
          Clock
    .col-auto
      .column.justify-center.items-center.full-height
        .col-auto
          Clock(:timezone="+2" :name="'Cairo'")
    .col-auto
      .column.justify-center.items-center.full-height
        .col-auto
          Clock(:timezone="+3" :name="'Nairobi'")
    .col-auto
      .column.justify-center.items-center.full-height
        .col-auto
          Clock(:timezone="+8" :name="'Kuala Lumpur'")
    .col
    .col-auto.bg-white
      .column.justify-center.items-center.full-height
        .col-auto
          img(src="@/assets/solferino.svg" style="width:180px;padding-top:8px;margin-left:20px;margin-right:20px;")
  .row
    .col(style="max-width:340px;")
      Twitter
    .col
      
      .row.reverse
        Tv(v-for="(cont,index) in Rsubmissions" :content="cont" :key="index" :large="index==8 || index==9" :cfurl="metadata.cloudfronturl" v-on:video-ended="ended(index)" v-on:cant-play="cantplay(index)")
</template>

<script>
import { db, getScreen } from "@/db";
import Clock from "@/components/Clock.vue";
import Tv from "@/components/Tv.vue";
import Twitter from "@/components/Twitter.vue";
import { sample, filter, reverse, last } from "lodash";

export default {
  name: "Screen",
  cache: null,
  components: { Clock, Tv, Twitter },
  meta() {
    return {
      title: "TV Display",
    };
  },
  computed: {
    Rsubmissions() {
      return reverse(this.submissions);
    },
  },
  methods: {
    async startCache() {
      // console.log("opening cache");
      this.cache = await caches.open("video-cache");
    },
    cantplay(index) {
      console.log("cantplay", index);
      this.submissions[index].played = true;
      if (this.submissions[index].live) this.ended(index);
    },
    ended(index) {
      console.log(`${index} ended`);
      if (this.batching) {
        console.log("Ignoring ended event as currently loading new content");
        return;
      }

      //just any old video ending, not the one we care about:
      if (index != -1 && !this.submissions[index].live) return;

      if (index != -1) this.submissions[index].live = false;

      const nxt = sample(
        filter(this.submissions, function(f) {
          return f.played === false;
        })
      );

      if (nxt && !this.waitingforcache) {
        console.log(`Making ${this.submissions.indexOf(nxt)} live`);
        this.$set(nxt, "live", true);
        this.$set(nxt, "played", true);
      } else {
        //reload?

        //if cache is ready:
        if (this.cacheprogress == this.TOLOAD) {
          this.waitingforcache = false;
          console.log("Cache download complete, changing videos");
          this.loadNextBatch();
        } else {
          //set all videos to be playable again:
          console.log("Cache download not complete, reset and play all again");

          //if its all played out:
          if (!nxt) {
            for (let index in this.submissions) {
              if (!this.submissions[index].dummy)
                this.submissions[index].played = false;
            }

            //set flag so we know that the next ended event will check for a cache ready
            this.waitingforcache = true;

            //choose a new random one to keep playing from
            const nxt = sample(
              filter(this.submissions, function(f) {
                return f.played === false;
              })
            );
            console.log(`Making ${this.submissions.indexOf(nxt)} live`);
            this.$set(nxt, "live", true);
            this.$set(nxt, "played", true);
          } else {
            //set this one to have already been played (as its playing now)
            this.$set(nxt, "live", true);
            this.$set(nxt, "played", true);
          }
        }
      }
    },
    async startMe() {
      this.hasClicked = true;
      await this.getSubmissions();
      this.loadNextBatch();
    },
    youtube(content) {
      // if (content.media) {
      //   const yt = find(content.media, { type: "hd_video" }).src.replace(
      //     "hd_video",
      //     "hd_video_tiny"
      //   );
      //   const url = yt.split("/");
      //   url.shift();
      //   url.shift();
      //   url.shift();
      return `${this.metadata.cloudfronturl}/submissions/${content.id}/hd_video_tiny.mp4`;
      // } else return false;
    },
    async getSubmissions() {
      try {
        this.loading = true;
        console.log("Start caching next set of content");

        // let ref = db.collection("submissions");
        // ref = ref.where("status", "==", "edited");
        // // ref = ref.where("phase", "==", this.terms.phase);
        // ref = ref.orderBy("createdAt", "desc");

        // // console.log(this.submissions);

        // if (this.lastSnap) {
        //   // const lastone = );
        //   // console.log(this.lastSnap._doc);
        //   ref = ref.startAfter(this.lastSnap._doc);
        // }

        // ref = ref.limit(this.TOLOAD);

        // this.submissions.splice(0, this.submissions.length);

        // await this.$bind("tmpsubs", ref, {
        //   maxRefDepth: 1,
        // });

        console.log(`lastsnap: ${this.lastSnap?.id}`);

        this.tmpsubs = (
          await getScreen({
            limit: this.TOLOAD,
            startAfter: this.lastSnap?.id,
          })
        ).data;

        // console.log(this.tmpsubs);

        // return;

        this.lastSnap = last(this.tmpsubs);

        // console.log(this.lastSnap._doc);

        // this.$set(this.toplay, []);

        /** START CACHE DOWNLOAD */

        // const keys = await this.cache.keys();

        // console.log(keys);
        this.cacheprogress = 0;
        for (let index of this.tmpsubs) {
          const url = this.youtube(index);

          const key = await this.cache.keys(url);
          // console.log(key);
          try {
            if (key.length === 0) {
              console.log(`Putting to Cache: ${url}`);
              await this.cache.add(url);
            } else {
              console.log(`Already in Cache: ${url}`);
            }
          } catch (e) {
            console.error(e);
          }
          this.cacheprogress++;
        }
      } catch (ex) {
        console.error(ex);
      }
      /* CACHE DOWNLOAD COMPLETE **/

      //in case there are not enough videos to fill the batch, set cache complete anyway:
      this.cacheprogress = this.TOLOAD;
      console.log("Finishing caching next set of content");

      // this.$unbind("tmpsubs", false);
      this.loading = false;

      let length = this.tmpsubs.length;

      this.actualcount = length;

      //check for end of the available content:
      if (this.actualcount == 0) {
        console.log("reached end of available reports");
        this.lastSnap = null;
        // this.submissions.splice(0, this.submissions.length);
        // this.batching = false;
        this.getSubmissions();
        return;
      }
      // } catch (e) {
      //   console.log(e);
      // }
    },
    async loadNextBatch() {
      this.batching = true;
      try {
        console.log("Loading next batch");
        let index = 0;
        //now we have data, clear out the old ones:
        for (let index in this.submissions) {
          this.$set(this.submissions, index, { dummy: true });
        }

        this.tmpsubs.forEach((doc) => {
          // console.log(doc.id);
          this.$set(this.submissions, index, {
            ...doc,
            ...{ live: false, played: false },
          });
          index++;
        });

        //start a random one playing:

        //load next batch into cache
        this.getSubmissions();

        // this.loading = false;
      } catch (e) {
        console.error(e);
      }
      this.batching = false;
      this.ended(-1);
    },
  },
  async created() {
    for (let i = 0; i < 10; i++) {
      this.submissions.push({ played: true, dummy: true });
    }
  },

  async mounted() {
    this.startCache();
    try {
      this.metadata = (
        await db
          .collection("config")
          .doc("meta")
          .get()
      ).data();
    } catch (e) {
      this.showError(e);
    }
  },
  data() {
    return {
      waitingforcache: false,
      cacheprogress: 0,
      loading: false,
      submissions: [],
      tmpsubs: [],
      actualcount: 0,
      toplay: [],
      lastSnap: null,
      metadata: {
        cloudfronturl: "",
      },
      hasClicked: false,
      TOLOAD: 10,
      batching: false,
    };
  },
};
</script>

<style scoped></style>
